package main

import (
	"git.randomchars.net/leva/hub/host/partial"
	"log"
	"os"
	"strings"
)

func pluginLoad() error {
	if entries, err := os.ReadDir("plugins"); err != nil {
		if os.IsNotExist(err) {
			if err = os.Mkdir("plugins", 0755); err != nil {
				return err
			} else {
				return nil
			}
		}
		log.Fatalf("Error reading plugins directory, %s", err)
		return nil
	} else {
		for _, entry := range entries {
			if !entry.IsDir() && strings.HasSuffix(entry.Name(), ".so") {
				if !partial.NewPlugin(entry.Name()).Register() {
					log.Printf("Plugin %s did not register.", entry.Name())
				}
			}
		}
	}

	for _, name := range partial.Plugins() {
		pl := partial.GetPlugin(name)
		if err := pl.Open(); err != nil {
			log.Printf("Error loading %s, %s", pl.Name, err)
		}
	}

	return nil
}
